{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TNumber = 0..15;
  TMatrix = array[1..7] of array[1..5] of char;

const
  numbers: array[TNumber] of TMatrix = (
  (
    '.###.',
    '#...#',
    '#..##',
    '#.#.#',
    '##..#',
    '#...#',
    '.###.'
  ),
  (
    '...##',
    '..#.#',
    '.#..#',
    '#...#',
    '....#',
    '....#',
    '....#'
  ),
  (
    '.###.',
    '#...#',
    '....#',
    '...#.',
    '..#..',
    '.#...',
    '#####'
  ),
  (
    '.###.',
    '#...#',
    '....#',
    '.###.',
    '....#',
    '#...#',
    '.###.'
  ),
  (
    '#...#',
    '#...#',
    '#...#',
    '#...#',
    '.####',
    '....#',
    '....#'
  ),
  (
    '#####',
    '#....',
    '#....',
    '####.',
    '....#',
    '#...#',
    '.###.'
  ),
  (
    '.###.',
    '#...#',
    '#....',
    '####.',
    '#...#',
    '#...#',
    '.###.'
  ),
  (
    '#####',
    '....#',
    '....#',
    '...#.',
    '..#..',
    '.#...',
    '#....'
  ),
  (
    '.###.',
    '#...#',
    '#...#',
    '.###.',
    '#...#',
    '#...#',
    '.###.'
  ),
  (
    '.###.',
    '#...#',
    '#...#',
    '.####',
    '....#',
    '#...#',
    '.###.'
  ),
  (
    '..#..',
    '.#.#.',
    '#...#',
    '#...#',
    '#####',
    '#...#',
    '#...#'
  ),
  (
    '####.',
    '#...#',
    '#...#',
    '####.',
    '#...#',
    '#...#',
    '####.'
  ),
  (
    '.###.',
    '#...#',
    '#....',
    '#....',
    '#....',
    '#...#',
    '.###.'
  ),
  (
    '###..',
    '#..#.',
    '#...#',
    '#...#',
    '#...#',
    '#..#.',
    '###..'
  ),
  (
    '#####',
    '#....',
    '#....',
    '####.',
    '#....',
    '#....',
    '#####'
  ),
  (
    '#####',
    '#....',
    '#....',
    '####.',
    '#....',
    '#....',
    '#....'
  )
  );
  space = 1;
  MaxQ = 16*16;
  MaxN = 40;
  MaxLength = 6*MaxN-1;

var a: array[1..MaxN] of TMatrix;
    symbols: array[0..MaxQ] of TMatrix;
    i, j, k, l: integer;
    s1, s2: string;
    fo: text;

procedure Ex(const s: string; ec: integer);
begin
  write(s);
  try
    close(fo);
  except
  end;
  halt(ec);
end;

procedure CheckString(s: string);
var i: integer;
begin
  for i := 1 to length(s) do
    if not (s[i] in ['0'..'9', 'A'..'F']) then
      Ex(format('Invalid character ''%s''(code: %d) in %d position', [s[i], ord(s[i]), i]), 3);
end;

function ApplySymbols(a, b: integer): TMatrix;
var i, j: integer;
begin
  Result := numbers[a];
  for i := 1 to 7 do
    for j := 1 to 5 do
      if Result[i, j] = '.' then Result[i, j] := numbers[b, i, j];
end;

function GetNum(c: char): integer;
begin
  if c in ['0'..'9'] then Result := ord(c) - ord('0') else Result := ord(c) - ord('A') + 10;
end;        

begin
  for i := 0 to 15 do
    for j := i to 15 do
      begin
        symbols[16*i+j] := ApplySymbols(i, j);
        symbols[16*j+i] := symbols[16*i+j];
      end;
  AssignFile(fo, 'input.txt');
  rewrite(fo);
  s1 := ParamStr(1);
  s2 := ParamStr(2);
  if length(s1) < length(s2) then s1 := s1 + copy(s2, length(s1)+1, length(s2) - length(s1));
  if length(s2) < length(s1) then s2 := s2 + copy(s1, length(s2)+1, length(s1) - length(s2));
  CheckString(s1); CheckString(s2);
  l := length(s1);
  for i := 1 to l do
    begin
      a[i] := symbols[GetNum(s1[i])*16+GetNum(s2[i])];
    end;
  for i := 1 to 7 do
    begin
      for j := 1 to l do
        begin
          if j > 1 then write(fo, '.');
          write(fo, a[j, i]);
        end;
      writeln(fo);
    end;
  CloseFile(fo);
end.
