{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TNumber = 0..15;
  TMatrix = array[1..7] of array[1..5] of char;

const
  numbers: array[TNumber] of TMatrix = (
  (
    '.###.',
    '#...#',
    '#..##',
    '#.#.#',
    '##..#',
    '#...#',
    '.###.'
  ),
  (
    '...##',
    '..#.#',
    '.#..#',
    '#...#',
    '....#',
    '....#',
    '....#'
  ),
  (
    '.###.',
    '#...#',
    '....#',
    '...#.',
    '..#..',
    '.#...',
    '#####'
  ),
  (
    '.###.',
    '#...#',
    '....#',
    '.###.',
    '....#',
    '#...#',
    '.###.'
  ),
  (
    '#...#',
    '#...#',
    '#...#',
    '#...#',
    '.####',
    '....#',
    '....#'
  ),
  (
    '#####',
    '#....',
    '#....',
    '####.',
    '....#',
    '#...#',
    '.###.'
  ),
  (
    '.###.',
    '#...#',
    '#....',
    '####.',
    '#...#',
    '#...#',
    '.###.'
  ),
  (
    '#####',
    '....#',
    '....#',
    '...#.',
    '..#..',
    '.#...',
    '#....'
  ),
  (
    '.###.',
    '#...#',
    '#...#',
    '.###.',
    '#...#',
    '#...#',
    '.###.'
  ),
  (
    '.###.',
    '#...#',
    '#...#',
    '.####',
    '....#',
    '#...#',
    '.###.'
  ),
  (
    '..#..',
    '.#.#.',
    '#...#',
    '#...#',
    '#####',
    '#...#',
    '#...#'
  ),
  (
    '####.',
    '#...#',
    '#...#',
    '####.',
    '#...#',
    '#...#',
    '####.'
  ),
  (
    '.###.',
    '#...#',
    '#....',
    '#....',
    '#....',
    '#...#',
    '.###.'
  ),
  (
    '###..',
    '#..#.',
    '#...#',
    '#...#',
    '#...#',
    '#..#.',
    '###..'
  ),
  (
    '#####',
    '#....',
    '#....',
    '####.',
    '#....',
    '#....',
    '#####'
  ),
  (
    '#####',
    '#....',
    '#....',
    '####.',
    '#....',
    '#....',
    '#....'
  )
  );
  space = 1;
  MaxQ = 16*16;
  MaxN = 40;
  MaxLength = 6*MaxN-1;

var symbols: array[0..MaxQ] of TMatrix;
    bill: array[1..MaxLength] of TMatrix;
    ans: array[1..MaxLength] of integer;
    s: string;
    i, j, k, l, p, c: integer;
    AllBad: boolean;
    fi, fo: text;

procedure CheckString;
begin
  assert((l+1) mod 6 = 0, 'Invalid string length: '+IntToStr(l));
  for j := 1 to l do
    begin
      assert(s[j] in ['.', '#'],
        format('Invalid character ''%s''(code: %d) in %d position', [s[j], ord(s[j]), j]));
    end;
      assert((0 < l) and (l <= MaxLength), 'Invalid string length: '+IntToStr(l));
end;

function GetAns(i: integer): integer;
begin
  Result := -1;
  for c := 0 to 255 do
    begin
      AllBad := false;
      for j := 1 to 7 do
        for p := 1 to 5 do
          begin
            AllBad := AllBad or (symbols[c, j, p] <> bill[i, j, p]);
          end;
      if not AllBad then Result := c;
    end;
end;

function ApplySymbols(a, b: integer): TMatrix;
var i, j: integer;
begin
  Result := numbers[a];
  for i := 1 to 7 do
    for j := 1 to 5 do
      if Result[i, j] = '.' then Result[i, j] := numbers[b, i, j];
end;

function GetChar(code: integer): string;
begin
  Result := format('%X', [code]);
end;

procedure botva;
begin
  write(fo, 'IMPOSSIBLE'); //     ! :'(      :-(
  CloseFile(fi);
  CloseFile(fo);
  halt(0);
end;

begin
  FillChar(symbols, SizeOf(symbols), '.');
  FillChar(bill, SizeOf(bill), '.');
  for i := 0 to 15 do
    for j := i to 15 do
      begin
        symbols[16*i+j] := ApplySymbols(i, j);
        symbols[16*j+i] := symbols[16*i+j];
      end;
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  for i := 1 to 7 do
    begin
      readln(fi, s);
      l := length(s);
      CheckString;
      k := 1; p := 1;
      for j := 1 to l do
        begin
          if p <> 0 then bill[k, i, p] := s[j] else if s[j] <> '.' then botva;
          inc(p);
          if p = 6 then
            begin
              p := 0;
              inc(k);
            end;
        end;
    end;
  dec(k);
  for i := 1 to k do
    begin
      ans[i] := GetAns(i);
      if ans[i] = -1 then botva;
    end;
  for j := 1 to 2 do
    begin
      for i := 1 to k do
        begin
          write(fo, GetChar(ans[i] and $F));
          ans[i] := ans[i] shr 4;
        end;
      writeln(fo);
    end;
  CloseFile(fi);
  CloseFile(fo);
end.
